# -*- coding: utf-8 -*-
# This file is part of ejercicio

# ejercicio is free software: you can redistribute it and/or modify
# it under the terms of the Python 2.6.2 license

# ejercicio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

# To read the license please read:
# http://www.python.org/download/releases/2.6.2/license/

# Author: Fabian Ezequiel Gallina <fgallina at from-the-cloud dot com>
import os
from usuario import Usuario

usuarios = []

def menu():
    print """
    Opciones:
        1: Cargar usuario
        2: Mostrar usuarios
        3: Salvar datos
        4: Cargar datos desde archivo
        5: Salir
    """

def cargar_usuario():
    global usuarios
    print "Ingrese nombre:"
    nombre = raw_input()
    print "Ingrese apellido:"
    apellido = raw_input()
    print "Ingrese teléfono:"
    telefono = raw_input()
    usuario = Usuario(nombre, apellido, telefono)
    usuarios.append(usuario)

def mostrar_usuarios():
    global usuarios
    for usuario in usuarios:
        print "ver usuario", usuario.nombre, usuario.apellido, "?(y):"
        opcion = raw_input()
        if opcion is not "y":
            break
        clear()
        usuario.mostrar()

def salvar_datos():
    global usuarios
    file = open('usuarios.csv', 'w')
    for usuario in usuarios:
        file.write(usuario.csv() + "\n")

def cargar_datos():
    global usuarios
    print "Cargando..."
    usuarios = []
    file = open('usuarios.csv', 'r')
    for line in file.readlines():
        attr = line.split(',');
        usuario = Usuario(attr[0], attr[1], attr[2][:-1])
        usuarios.append(usuario)
    print "Datos Cargados"

def clear():
    if os.name == 'posix':
        os.system('clear')
    elif os.name in ('nt', 'dos', 'ce'):
        os.system('CLS')
    else:
        print "\n" * 100

def main():
    opciones = {1: cargar_usuario,
                2: mostrar_usuarios,
                3: salvar_datos,
                4: cargar_datos,
                5: exit}

    while True:
        menu()
        opcion = int(raw_input())
        clear()
        opciones[opcion]()


if __name__ == '__main__':
    main()
