AutoInteractiveShell.clear()
# definiendo funciones

# para definir una función usamos def
def funcion(arg1, arg2, karg1="valor", karg2="otro valor"):
    """documentación de la función que se muestra con help()"""
    print "arg1 ==", arg1
    print "arg2 ==", arg2
    print "karg1 ==", karg1
    print "karg2 ==", karg2

# los argumentos posicionales siempre deben tener un valor
funcion("arg1", "arg2")

# los keyword arguments pueden ser llamados en cualquier orden
funcion("arg1", "arg2", karg2="valor modificado")

# también podemos respetar la posición de los keyword arguments
funcion("arg1", "arg2", "karg1", "karg2")

# si damos más de un valor para un keyword argument una excepción se lanzará
funcion("arg1", "arg2", "karg1", karg1="karg2")

# de la misma forma los keywords arguments deben ser definidos luego de los posicionales
def fail(kw1 = "esto no va a andar", arg):
    print kw1
AutoInteractiveShell.clear()

# paso por referencia

lista = ['l', 'i', 's', 't', 'a']
# las variables en python son referencias a objetos, si el tipo de
# dato de la variable que pasamos a una función es mutable entonces
# esa variable va a modificarse cuando operemos con ella
def modificar(lista):
    lista.pop()

lista
modificar(lista)
lista

# distinto es si el tipo de dato es mutable pero creamos una variable
# dentro del namespace de la función.
# En este caso la variable lista de la funcion es una variable local.
def modificar(lista):
    lista = [1, 2, 3, 4, 5]

lista
modificar(lista)
lista

AutoInteractiveShell.clear()

# funciones anónimas (lambda)
# las funciones anónimas sólo pueden contener una sentencia
# pero pueden contener cualquier cantidad de argumentos e incluso
# argumentos posicionales.
lambda x=1,y=2: list(x,y)

# no pueden contener ordenes (print, return, yield...)
lambda x, y: return x #error

# su utilidad se evidencia en funciones como reduce que piden una
# función como parámetro
lista = [1, 2, 3, 4]
help(reduce)
reduce(lambda x,y: x+y, lista)

AutoInteractiveShell.clear()

# Generadores
# funcion normal
def cuadrados(hasta):
    indice = 1
    cuadrados = []
    while indice <= hasta:
        cuadrados.append(indice**2)
        indice += 1
    return cuadrados

cuadrados(30)

def xcuadrados(hasta):
    indice = 1
    cuadrado = 1
    while indice <= hasta:
        yield cuadrado
        indice += 1
        cuadrado = indice ** 2

g = xcuadrados(30) # crea un generador
g

# es iterable con un for
for i in g:
    print i

# por supuesto que esto también funciona
for i in xcuadrados(2):
    print i

c = xcuadrados(2) # el generador devuelve un objeto generador iterable
c.next() # podemos ir pidiendo los valores con next()
c.next()
c.next()
c.next() # cuando no hay nada que devolver se lanza la excepción StopIteration

AutoInteractiveShell.clear()

# decoradores
# los decoradores nos permiten modificar el comportamiento de una
# función envolviendola en otra.
# una de sus utilidades más obvias es el logging
def funcion(arg1):
    return arg1

print funcion("test")

# un decorador generalmente tiene otra función anidada ya que el
# decorador espera retornar un callable (metodo, funcion o clase)
def decorador(func):
    def wrapper(*args, **kwargs):
        print "ejecutando función:", func.__name__
        print "Argumentos posicionales:", str(args)
        print "Keyword Arguments: ", str(kwargs)
        return func("modificada")
    return wrapper

# esto es el equivalente a decorador(funcion)
@decorador
def funcion(arg1):
    return arg1

print funcion("test")
AutoInteractiveShell.clear()
